# -*- coding: utf-8 -*-

import os, sys, StringIO
import urllib, urllib2
import unicodedata, struct, shutil, gzip
import xbmc, xbmcvfs, xbmcaddon, xbmcplugin, xbmcgui

__addon__ = xbmcaddon.Addon()
__scriptid__ = __addon__.getAddonInfo('id')
__scriptname__ = __addon__.getAddonInfo('name')
__version__ = __addon__.getAddonInfo('version')
__language__ = __addon__.getLocalizedString

__cwd__ = xbmc.translatePath(__addon__.getAddonInfo('path')).decode("utf-8")
__profile__ = xbmc.translatePath(__addon__.getAddonInfo('profile')).decode("utf-8")
__resource__ = xbmc.translatePath(os.path.join(__cwd__, 'resources', 'lib')).decode("utf-8")
__temp__ = xbmc.translatePath(os.path.join(__profile__, 'temp', '')).decode("utf-8")

sys.path.append(__resource__)

def normalizeString(str):
    return unicodedata.normalize(
        'NFKD', unicode(unicode(str, 'latin-1'))
    ).encode('ascii', 'ignore').decode('latin-1').encode("utf-8")

def log(module, msg):
    xbmc.log((u"### [%s] - %s" % (module, msg,)).encode('utf-8'), level=xbmc.LOGNOTICE)

req_url = "http://napisy24.pl/run/CheckSubAgent.php"
login = "sdxbmc"
pwd = "qazxsw123"

def http_response_content(response):
    if response.info().get('Content-Encoding') == 'gzip':
        buf = StringIO.StringIO(response.read())
        f = gzip.GzipFile(fileobj=buf)
        content = f.read()
    else:
        content = response.read()

    return content

def hashFile(name):
    longlongformat = '<q'
    bytesize = struct.calcsize(longlongformat)

    f = open(name, "rb")

    filesize = os.path.getsize(name)
    hash = filesize

    if filesize < 65536 * 2:
        return "SizeError"

    for x in range(65536/bytesize):
        buffer = f.read(bytesize)
        (l_value,)= struct.unpack(longlongformat, buffer) 
        hash += l_value
        hash = hash & 0xFFFFFFFFFFFFFFFF 


    f.seek(max(0,filesize-65536),0)
    for x in range(65536/bytesize):
        buffer = f.read(bytesize)
        (l_value,)= struct.unpack(longlongformat, buffer)
        hash += l_value
        hash = hash & 0xFFFFFFFFFFFFFFFF

    f.close()
    returnedhash =  "%016x" % hash
    return returnedhash

def generateTemporaryFile(tFile):
    if xbmcvfs.exists(__temp__):
        shutil.rmtree(__temp__)
    xbmcvfs.mkdirs(__temp__)
    
    xbmc.sleep(500)

    zip_filename = os.path.join(__temp__, "subs.zip")
    with open(zip_filename, "wb") as subFile:
        subFile.write(tFile)
    subFile.close()

def Search(item):
    params = {"postAction": "CheckSub", "ua": login, "ap": pwd, "fs": item["file_original_size"], "fh": item["hash"], "fn": item["file_original_name"]}
    
    request = urllib2.Request(req_url, urllib.urlencode(params))
    response = urllib2.urlopen(request)
    content = http_response_content(response)
    
    responseParams = content.split("||", 1)
    
    log(__scriptname__, normalizeString(responseParams[0]))
    log(__scriptname__, urllib.urlencode(params))

    responseItems = {}
    for el in responseParams[0].split("|", 1):
        responseItems[el[0]] = el[1]
    
    log(__scriptname__, str(responseItems))
    
    language = "pl"

    listitem = xbmcgui.ListItem(label=xbmc.convertLanguage(language, xbmc.ENGLISH_NAME),
                                label2=item["file_original_name"],
                                iconImage="0",
                                thumbnailImage=xbmc.convertLanguage(language, xbmc.ISO_639_1)
    )
    listitem.setProperty("sync", "true")
    listitem.setProperty("hearing_imp", "false")
    generateTemporaryFile(responseParams[1])

    url = "plugin://%s/?action=download&id=%d" % (__scriptid__, 666)
    xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=listitem, isFolder=False)

def Download():  #standard input
    subtitle_list = []
    exts = [".srt", ".sub", ".txt"]
    zip_filename = os.path.join(__temp__, "subs.zip")

    xbmc.executebuiltin(('XBMC.Extract("%s","%s")' % (zip_filename, __temp__,)).encode('utf-8'), True)

    for file in xbmcvfs.listdir(__temp__)[1]:
        full_path = os.path.join(__temp__, file)
        if os.path.splitext(full_path)[1] in exts and file != 'Napisy24.pl.srt':
            subtitle_list.append(full_path)

    return subtitle_list

def get_params():
    param = []
    paramstring = sys.argv[2]
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]

    return param

params = get_params()

if params['action'] in ['search', 'manualsearch']:
    item = {}
    item['temp'] = False
    item['rar'] = False
    item['year'] = xbmc.getInfoLabel("VideoPlayer.Year")  # Year
    item['season'] = str(xbmc.getInfoLabel("VideoPlayer.Season"))  # Season
    item['episode'] = str(xbmc.getInfoLabel("VideoPlayer.Episode"))  # Episode
    item['tvshow'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.TVshowtitle"))  # Show
    item['title'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.OriginalTitle"))  # try to get original title
    item['file_original_path'] = urllib.unquote(xbmc.Player().getPlayingFile().decode('utf-8'))  # Full path of a playing file
    item['file_original_name'] = os.path.basename(item['file_original_path']) # Name of playing file
    item['3let_language'] = []
    item['preferredlanguage'] = unicode(urllib.unquote(params.get('preferredlanguage', '')), 'utf-8')
    item['preferredlanguage'] = xbmc.convertLanguage(item['preferredlanguage'], xbmc.ISO_639_2)

    for lang in urllib.unquote(params['languages']).decode('utf-8').split(","):
        item['3let_language'].append(xbmc.convertLanguage(lang, xbmc.ISO_639_2))

    if item['title'] == "":
        item['title'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.Title"))  # no original title, get just Title

    if item['episode'].lower().find("s") > -1:  # Check if season is "Special"
        item['season'] = "0"  #
        item['episode'] = item['episode'][-1:]

    if ( item['file_original_path'].find("http") > -1 ):
        item['temp'] = True

    elif ( item['file_original_path'].find("rar://") > -1 ):
        item['rar'] = True
        item['file_original_path'] = os.path.dirname(item['file_original_path'][6:])

    elif ( item['file_original_path'].find("stack://") > -1 ):
        stackPath = item['file_original_path'].split(" , ")
        item['file_original_path'] = stackPath[0][8:]

    if item['tvshow'] and params['action'] == "manualsearch":
        item['tvshow'] = params['searchstring']
    elif params['action'] == "manualsearch":
        item['title'] = params['searchstring']

    item["file_original_size"] = xbmcvfs.File(item["file_original_path"]).size()
    
    item["hash"] = hashFile(item["file_original_path"])

    log(__scriptname__, "item: %s" %(item))

    Search(item)

elif params['action'] == 'download':
    subs = Download()
    for sub in subs:
        listitem = xbmcgui.ListItem(label=sub)
        xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=sub, listitem=listitem, isFolder=False)

xbmcplugin.endOfDirectory(int(sys.argv[1]))  ## send end of directory to XBMC
